#
# To build against different kernel use: --define "kernel_version VERSION-RELEASE"
#

# Q: should we try to build "timesource" driver?
# A: not yet - it cannot be build in a kernel-independent way
%define with_timesource 0
# Q: should we install "hid" driver?
# A: Not anymore - starting with 2.6.18-308.20.1.el5 it requires ksym(hidraw_report_event)
#    so not possible to  build in a kernel-independent way
%define with_hid 0

Name: mshvic
Version: 2.1.2
Release: 19%{?dist}
License: BSD/GPLv2
Group: System/Kernel
Summary: Linux Integration Services for Hyper-V (TM)
Packager: Linux.Support@cern.ch
Vendor: CERN, http://cern.ch/linux
Source0: LinuxIC-BSD-GPL.tar.bz2
Source1: %{name}-depmod.conf
#Source2: %{name}-mkinitrd.conf
Source3: %{name}-depmod-timesource.conf
#Source4: %{name}-mkinitrd-timesource.conf
Source5: %{name}-trigger.pl
Patch0: rhel6.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-build
Provides: %{name}-kmod-common = %{?epoch:%{epoch}:}%{version}

Source1111: slc-kmodtool-mshvic
Source1112: slc6-kmodtool-mshvic

%if %{with_hid}
   Source6: inputvsc.tgz
%endif

%if "%{dist}" == ".slc5"
BuildRequires: %kernel_module_package_buildreqs
%endif

%if %{with_timesource}
BuildRequires: adjtimex
%endif
%ifarch x86_64
Requires: adjtimex
%endif

%define upvar default
%ifarch i686
%define paevar PAE
%endif
#%ifarch i686 ia64 x86_64
#%define xenvar xen
#%endif

%if "%{dist}" == ".slc5"
%kernel_module_package -s %{SOURCE1111} %{?upvar} %{?paevar}
%endif
%if "%{dist}" == ".slc6"
%kernel_module_package -s %{SOURCE1112} %{?upvar} %{?paevar}
%endif


%description
Linux Integration Services for Hyper-V (TM) in
Windows Server 2008, Windows Server 2008 R2, Microsoft
Hyper-V Server 2008 and Microsoft Hyper-V Server 2008 R2.

Contains drivers for the following:
VMBus
Microsoft synthetic SCSI controller
Microsoft synthetic network adapter

Copyright (c) 2010, Microsoft Corporation.

Version : 2.1.2
Date    : March 31, 2010

The "inputvsc" driver from Satori (http://www.xen.org/products/satori.html)
enables the synthetic mouse.

In addition, the GRUB configuration is updated to workaround
problems with clock drift.

%prep
%setup -c -n %{name}-%{version}/
set -- *
mkdir source
#ls -l
mv "$@" source/
%if %{with_hid}
   %{__tar} -xzvf %{SOURCE6} -C source/
%endif
mkdir obj
%if "%{dist}" == ".slc6"
cd source/*
%patch0 -p1
%endif

%build
for flavor in %{flavors_to_build} ; do
   rm -rf obj/$flavor
   cp -r source obj/$flavor
   make -C %{kernel_source $flavor} M=`pwd`/obj/$flavor/LinuxIC-BSD-GPL/src/
%if %{with_timesource}
   make -C %{kernel_source $flavor} M=`pwd`/obj/$flavor/LinuxIC-BSD-GPL/src/ obj-m=hv_timesource.o
%endif
%if %{with_hid}
   make -C %{kernel_source $flavor} M=`pwd`/obj/$flavor/inputvsc/dist/hid
   make -C %{kernel_source $flavor} M=`pwd`/obj/$flavor/inputvsc/dist/inputvsc
%endif
done

%install
for flavor in %flavors_to_build ; do 
   kmodloc="$RPM_BUILD_ROOT/lib/modules/%{kernel_version}"
   if [ "$flavor" != "default" ]; then
      kmodloc="$kmodloc$flavor"
   fi
   kmodloc="$kmodloc/extra"
   install -d -m0755 $kmodloc/
   install -m0755 obj/$flavor/LinuxIC-BSD-GPL/src/vmbus.ko $kmodloc/
   install -m0755 obj/$flavor/LinuxIC-BSD-GPL/src/blkvsc.ko $kmodloc/
   install -m0755 obj/$flavor/LinuxIC-BSD-GPL/src/storvsc.ko $kmodloc/
   install -m0755 obj/$flavor/LinuxIC-BSD-GPL/src/netvsc.ko $kmodloc/
%if %{with_timesource}
   install -m0755 obj/$flavor/LinuxIC-BSD-GPL/src/hv_timesource.ko $kmodloc/
%endif
%if %{with_hid}
   install -m0755 obj/$flavor/inputvsc/dist/hid/hid.ko $kmodloc/
   install -m0755 obj/$flavor/inputvsc/dist/inputvsc/inputvsc.ko $kmodloc/
%endif
done
install -d -m0755 $RPM_BUILD_ROOT/%{_sysconfdir}/vmbus
install -m0755 source/LinuxIC-BSD-GPL/scripts/vmbus.uevent $RPM_BUILD_ROOT/%{_sysconfdir}/vmbus/
install -m0755 source/LinuxIC-BSD-GPL/scripts/netvsc.uevent $RPM_BUILD_ROOT/%{_sysconfdir}/vmbus/
install -d -m0755 $RPM_BUILD_ROOT/%{_sysconfdir}/udev/rules.d
install -m0644 source/LinuxIC-BSD-GPL/scripts/20-vmbus.rules $RPM_BUILD_ROOT/%{_sysconfdir}/udev/rules.d/
echo "" >> $RPM_BUILD_ROOT/%{_sysconfdir}/udev/rules.d/20-vmbus.rules # add missing newline :)
install -m0644 source/LinuxIC-BSD-GPL/scripts/20-netvsc.rules $RPM_BUILD_ROOT/%{_sysconfdir}/udev/rules.d/

install -d -m0755 $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/
install -m0755 source/LinuxIC-BSD-GPL/scripts/vmbus $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/

install -d -m0755 $RPM_BUILD_ROOT/%{_sysconfdir}/depmod.d/
%if ! %{with_timesource}
install -m0644 %{SOURCE1} $RPM_BUILD_ROOT/%{_sysconfdir}/depmod.d/%{name}.conf
%else
install -m0644 %{SOURCE3} $RPM_BUILD_ROOT/%{_sysconfdir}/depmod.d/%{name}.conf
%endif
install -d -m0755 $RPM_BUILD_ROOT/var/lib/%{name}/
install -d -m0755 $RPM_BUILD_ROOT/usr/sbin
install -m0755 %{SOURCE5} $RPM_BUILD_ROOT/usr/sbin/

%if %{with_hid}
   install -m0644 source/inputvsc/dist/tools/udev/60-inputvsc.rules $RPM_BUILD_ROOT/%{_sysconfdir}/udev/rules.d/
%endif
#install -m0755 source/inputvsc/dist/tools/init.d/inputvsc $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/
#install -m0755 source/inputvsc/dist/tools/scripts/updatexorg.pl $RPM_BUILD_ROOT/usr/sbin/
#install -d -m0755 $RPM_BUILD_ROOT/%{_sysconfdir}/modprobe.d/

%clean
rm -rf %{buildroot}

%post
#echo "Enable MSHVIC services"
/sbin/chkconfig --add vmbus || :
/sbin/chkconfig --levels 345 vmbus on ||:
%if "%{dist}" == ".slc5"
/sbin/udevcontrol reload_rules ||:
%endif
%if "%{dist}" == ".slc6"
/sbin/udevadm control --reload-rules ||:
%endif
#/sbin/chkconfig --add inputvsc || :

%preun
[ $1 = 0 ] && /usr/sbin/mshvic-trigger.pl uninstall ||:

%postun
%if "%{dist}" == ".slc5"
/sbin/udevcontrol reload_rules ||:
%endif
%if "%{dist}" == ".slc6"
/sbin/udevadm control --reload-rules ||:
%endif

%files
%defattr(-,root,root,-)
%config %{_sysconfdir}/depmod.d/%{name}.conf
%{_sysconfdir}/init.d/vmbus
%config %{_sysconfdir}/vmbus/vmbus.uevent
%config %{_sysconfdir}/vmbus/netvsc.uevent
%config %{_sysconfdir}/udev/rules.d/20-vmbus.rules
%config %{_sysconfdir}/udev/rules.d/20-netvsc.rules
/usr/sbin/mshvic-trigger.pl
%dir /var/lib/mshvic
%doc source/LinuxIC-BSD-GPL/LICENSE-GPL source/LinuxIC-BSD-GPL/LICENSE-DUAL-BSD-GPL source/LinuxIC-BSD-GPL/README source/LinuxIC-BSD-GPL/docs/LinuxIC_UserGuide.pdf

%if %{with_hid}
   %config %{_sysconfdir}/udev/rules.d/60-inputvsc.rules
%endif
#%{_sysconfdir}/modprobe.d/inputvsc.conf
#%{_sysconfdir}/init.d/inputvsc
#/usr/sbin/updatexorg.pl
#sb %doc source/inputvsc/LICENSE.txt

%changelog
* Tue Dec 11 2012 Sebastian Bukowiec <Sebastian.Bukowiec@cern.ch> 2.1.2-19
- change in the mshvic-trigger.pl that implements workaround for update from RH58 to RH59 version
- remove inputvsc, starting with 2.6.18-308.20.1.el5 it requires ksym(hidraw_report_event)
  so not possible to  build in a kernel-independent way 

* Mon Dec 20 2010 Jan van Eldik <Jan.van.Eldik@cern.ch> 2.1.2-18
- include inputvsc driver to enable syntetic mouse
- updates to prepare for SLC6 support

* Mon Dec 20 2010 Jan van Eldik <Jan.van.Eldik@cern.ch> 2.1.2-16
- [x86_64] add 'Requires: adjtimex' to try to prevent kernel panic on machines w/o network

* Thu Nov 11 2010 Jan van Eldik <Jan.van.Eldik@cern.ch> 2.1.2-15
- add 'clock=pmtmr' to kernel cmdline on x86_64, as needed to fix
  clock drift issue addressed in kernel-2.6.18-194.26.1.el5

* Fri Oct  1 2010  KELEMEN Peter <Peter.Kelemen@cern.ch> 2.1.2-14
- fix multiple installed versions by not triggering yum kernel module plugin

* Thu Sep 30 2010 Jan van Eldik <Jan.van.Eldik@cern.ch> 2.1.2-13
- use /var/lib/mshvic to save state

* Wed Sep 22 2010 Jan van Eldik <Jan.van.Eldik@cern.ch> 2.1.2-12
- documentation update

* Tue Aug 24 2010 Jan van Eldik <Jan.van.Eldik@cern.ch> 2.1.2-11
- upgrade to officially released Integration Components:
   http://www.microsoft.com/downloads/details.aspx?displaylang=en&FamilyID=eee39325-898b-4522-9b4c-f4b5b9b64551
- improvements in mshvic-trigger script:
  - don't run mshvic-trigger script in %post install
  - drop /etc/sysconfig/network-scripts/ifcfg-seth{0,1} from the packaging
  - many cleanups

* Thu Jun 17 2010 Jan van Eldik <Jan.van.Eldik@cern.ch> 2.1.2-RC.10
- drop building for kernel-xen, many small fixes

* Fri Jun 04 2010 Jaroslaw Polok <jaroslaw.polok@cern.ch>
- added better config script, added trigger by rpm.

* Mon May 17 2010 Jaroslaw Polok <jaroslaw.polok@cern.ch>
- updated to 2.1.2 rc1

* Fri Apr 30 2010 Jaroslaw Polok <jaroslaw.polok@cern.ch> 
- initial version
- packaging changed to DUP: http://driverupdateprogram.com/
